'ﾏﾄﾘｯｸｽﾃﾞｰﾀ計算の実行ﾌﾟﾛｸﾞﾗﾑ
Imports System.Drawing

Public Class Bars3EPVRCal3a
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        Me.PictureBox1 = New System.Windows.Forms.PictureBox()
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(128, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(184, 24)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "マトリックスデータ計算の実行"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(40, 96)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(280, 16)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Label3"
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(48, 232)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(336, 24)
        Me.ProgressBar1.TabIndex = 5
        '
        'PictureBox1
        '
        Me.PictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox1.Location = New System.Drawing.Point(128, 168)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(144, 24)
        Me.PictureBox1.TabIndex = 6
        Me.PictureBox1.TabStop = False
        '
        'Bars3EPVRCal3a
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(432, 278)
        Me.Controls.Add(Me.PictureBox1)
        Me.Controls.Add(Me.ProgressBar1)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Name = "Bars3EPVRCal3a"
        Me.Text = "Bars3EPVRCal3a"
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim Fw1, Fw2 As Single      '進行表示の水平枠位置
    Dim Crate As Single         '混合要素におけるﾗｰﾒﾝ要素追加微小比

    Dim CosXBar(,) As Single    '部材断面X軸の全体X,Y,Z軸に対する方向余弦
    Dim CosZBar(,) As Single    '部材断面Z軸の全体X,Y,Z軸に対する方向余弦
    Dim Em(,), Emb(,) As Single '要素の質量ﾏﾄﾘｯｸｽ計算の配列
    Dim RlenBar() As Single     '部材長さ
    Dim RMmatb() As Single     '全変位方向の質量ﾏﾄﾘｯｸｽ
    Dim Trans(,) As Single      '座標変換ﾏﾄﾘｯｸｽ

    Private Sub CoeffMatrix(ByVal ie As Integer)
        '各要素の係数ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        Dim ib, j, k, kp As Integer
        Dim area, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10, cmass As Single
        Dim r2, riy, riz, rlen, rlen2, rou, sm As Single

        kp = NumMat(ie)
        area = DataMat(kp, 4)
        riy = DataMat(kp, 5)
        riz = DataMat(kp, 6)
        rou = RouMat(kp)
        rlen = RlenBar(ie)
        rlen2 = rlen * rlen

        cmass = rou * area * rlen
        c1 = cmass / 3
        c2 = 0.5 * c1
        Select Case Ntype
            Case 1
                Em(1, 1) = c1 : Em(1, 4) = c2
                Em(2, 2) = c1 : Em(2, 5) = c2
                Em(3, 3) = c1 : Em(3, 6) = c2
                Em(4, 1) = c2 : Em(4, 4) = c1
                Em(5, 2) = c2 : Em(5, 5) = c1
                Em(6, 3) = c2 : Em(6, 6) = c1
            Case 2
                c3 = 13 * cmass / 35
                c4 = 11 * cmass * rlen / 210
                c5 = 9 * cmass / 70
                c6 = 13 * cmass * rlen / 420
                r2 = (riy + riz) / area
                c7 = cmass * r2 / 3
                c8 = 0.5 * c7
                c9 = cmass * rlen2 / 105
                c10 = cmass * rlen2 / 140
                Em(1, 1) = c1 : Em(1, 7) = c2 : Em(7, 1) = c2
                Em(2, 2) = c3 : Em(2, 6) = c4 : Em(6, 2) = c4
                Em(2, 8) = c5 : Em(8, 2) = c5 : Em(2, 12) = -c6 : Em(12, 2) = -c6
                Em(3, 3) = c3 : Em(3, 5) = -c4 : Em(5, 3) = -c4
                Em(3, 9) = c5 : Em(9, 3) = c5 : Em(3, 11) = c6 : Em(11, 3) = c6
                Em(4, 4) = c7 : Em(4, 10) = c8 : Em(10, 4) = c8
                Em(5, 5) = c9 : Em(5, 9) = -c6 : Em(9, 5) = -c6
                Em(5, 11) = -c10 : Em(11, 5) = -c10
                Em(6, 6) = c9 : Em(6, 8) = c6 : Em(8, 6) = c6
                Em(6, 12) = -c10 : Em(12, 6) = -c10
                Em(7, 7) = c1 : Em(8, 8) = c3 : Em(8, 12) = -c4 : Em(12, 8) = -c4
                Em(9, 9) = c3 : Em(9, 11) = c4 : Em(11, 9) = c4
                Em(10, 10) = c7 : Em(11, 11) = c9 : Em(12, 12) = c9
        End Select

        For ib = 1 To Nvar
            For j = 1 To Nvar
                sm = 0
                For k = 1 To Nvar
                    sm = sm + Em(ib, k) * Trans(k, j)
                Next k
                Emb(ib, j) = sm
            Next j
        Next ib

        For ib = 1 To Nvar
            For j = 1 To Nvar
                sm = 0
                For k = 1 To Nvar
                    sm = sm + Trans(k, ib) * Emb(k, j)
                Next k
                Em(ib, j) = sm
            Next j
        Next ib

    End Sub

    Private Sub CoeffMatrix2(ByVal ie As Integer)
        '各要素の係数ﾏﾄﾘｯｸｽの計算
        'kc･･･要素種類（1:ﾄﾗｽ、2:ﾗｰﾒﾝ、3:左端回転自由、4:右端回転自由）
        'ie･･･要素番号
        Dim ib, j, k, kc, kp As Integer
        Dim area, c1, c2, c3, c4, c5, c6, c7, c8, c9, c10, cb, cmass As Single
        Dim r2, riy, riz, rlen, rlen2, rou, sm As Single

        cb = 1.0 - Crate
        kc = KindElem(ie)
        kp = NumMat(ie)
        area = DataMat(kp, 4)
        riy = DataMat(kp, 5)
        riz = DataMat(kp, 6)
        rou = RouMat(kp)
        rlen = RlenBar(ie)
        rlen2 = rlen * rlen

        cmass = rou * area * rlen
        c1 = cmass / 3
        c2 = 0.5 * c1
        Em(1, 1) = c1 : Em(1, 7) = c2
        Em(7, 1) = c2 : Em(7, 7) = c1
        Select Case kc
            Case 1
                Em(2, 2) = c1 : Em(2, 8) = c2
                Em(3, 3) = c1 : Em(3, 9) = c2
                Em(8, 2) = c2 : Em(8, 8) = c1
                Em(9, 3) = c2 : Em(9, 9) = c1
            Case 2
                c3 = 13 * cmass / 35
                c4 = 11 * cmass * rlen / 210
                c5 = 9 * cmass / 70
                c6 = 13 * cmass * rlen / 420
                r2 = (riy + riz) / area
                c7 = cmass * r2 / 3
                c8 = 0.5 * c7
                c9 = cmass * rlen2 / 105
                c10 = cmass * rlen2 / 140
                Em(2, 2) = c3 : Em(2, 6) = c4 : Em(6, 2) = c4
                Em(2, 8) = c5 : Em(8, 2) = c5 : Em(2, 12) = -c6 : Em(12, 2) = -c6
                Em(3, 3) = c3 : Em(3, 5) = -c4 : Em(5, 3) = -c4
                Em(3, 9) = c5 : Em(9, 3) = c5 : Em(3, 11) = c6 : Em(11, 3) = c6
                Em(4, 4) = c7 : Em(4, 10) = c8 : Em(10, 4) = c8
                Em(5, 5) = c9 : Em(5, 9) = -c6 : Em(9, 5) = -c6
                Em(5, 11) = -c10 : Em(11, 5) = -c10
                Em(6, 6) = c9 : Em(6, 8) = c6 : Em(8, 6) = c6
                Em(6, 12) = -c10 : Em(12, 6) = -c10
                Em(8, 8) = c3 : Em(8, 12) = -c4 : Em(12, 8) = -c4
                Em(9, 9) = c3 : Em(9, 11) = c4 : Em(11, 9) = c4
                Em(10, 10) = c7 : Em(11, 11) = c9 : Em(12, 12) = c9
            Case 3
                Em(2, 2) = cmass / 5
                Em(2, 8) = 2 * cmass / 15
                Em(2, 12) = -cmass * rlen / 20
                Em(3, 3) = Em(2, 2)
                Em(3, 9) = Em(2, 8)
                Em(3, 11) = -Em(2, 12)
                Em(8, 8) = 8 * cmass / 15
                Em(8, 12) = -7 * cmass * rlen / 60
                Em(9, 9) = Em(8, 8)
                Em(9, 11) = -Em(8, 12)
                Em(11, 11) = cmass * rlen2 / 30
                Em(12, 12) = Em(11, 11)
                Em(8, 2) = Em(2, 8) : Em(9, 3) = Em(3, 9)
                Em(11, 3) = Em(3, 11) : Em(11, 9) = Em(9, 11)
                Em(12, 2) = Em(2, 12) : Em(12, 8) = Em(8, 12)
            Case 4
                Em(2, 2) = 8 * cmass / 15
                Em(2, 6) = 7 * cmass * rlen / 60
                Em(2, 8) = 2 * cmass / 15
                Em(3, 3) = Em(2, 2)
                Em(3, 5) = -Em(2, 6)
                Em(3, 9) = Em(2, 8)
                Em(5, 5) = cmass * rlen2 / 30
                Em(5, 9) = -cmass * rlen / 20
                Em(6, 6) = Em(5, 5)
                Em(6, 8) = -Em(5, 9)
                Em(8, 8) = cmass / 5
                Em(9, 9) = Em(8, 8)
                Em(5, 3) = Em(3, 5) : Em(6, 2) = Em(2, 6)
                Em(8, 2) = Em(2, 8) : Em(8, 6) = Em(6, 8)
                Em(9, 3) = Em(3, 9) : Em(9, 5) = Em(5, 9)
        End Select
        If kc > 2 Then
            c3 = 13 * cmass / 35
            c4 = 11 * cmass * rlen / 210
            c5 = 9 * cmass / 70
            c6 = 13 * cmass * rlen / 420
            r2 = (riy + riz) / area
            c7 = cmass * r2 / 3
            c8 = 0.5 * c7
            c9 = cmass * rlen2 / 105
            c10 = cmass * rlen2 / 140
            Em(2, 2) = cb * Em(2, 2) + Crate * c3
            Em(2, 6) = cb * Em(2, 6) + Crate * c4
            Em(6, 2) = Em(2, 6)
            Em(2, 8) = cb * Em(2, 8) + Crate * c5
            Em(8, 2) = Em(2, 8)
            Em(2, 12) = cb * Em(2, 12) - Crate * c6
            Em(12, 2) = Em(2, 12)
            Em(3, 3) = cb * Em(3, 3) + Crate * c3
            Em(3, 5) = cb * Em(3, 5) - Crate * c4
            Em(5, 3) = Em(3, 5)
            Em(3, 9) = cb * Em(3, 9) + Crate * c5
            Em(9, 3) = Em(3, 9)
            Em(3, 11) = cb * Em(3, 11) + Crate * c6
            Em(11, 3) = Em(3, 11)
            Em(4, 4) = Crate * c7
            Em(4, 10) = Crate * c8
            Em(10, 4) = Em(4, 10)
            Em(5, 5) = cb * Em(5, 5) + Crate * c9
            Em(5, 9) = cb * Em(5, 9) - Crate * c6
            Em(9, 5) = Em(5, 9)
            Em(5, 11) = -Crate * c10
            Em(11, 5) = Em(5, 11)
            Em(6, 6) = cb * Em(6, 6) + Crate * c9
            Em(6, 8) = cb * Em(6, 8) + Crate * c6
            Em(8, 6) = Em(6, 8)
            Em(6, 12) = -Crate * c10
            Em(12, 6) = Em(6, 12)
            Em(8, 8) = cb * Em(8, 8) + Crate * c3
            Em(8, 12) = cb * Em(8, 12) - Crate * c4
            Em(12, 8) = Em(8, 12)
            Em(9, 9) = cb * Em(9, 9) + Crate * c3
            Em(9, 11) = cb * Em(9, 11) + Crate * c4
            Em(11, 9) = Em(9, 11)
            Em(10, 10) = Crate * c7
            Em(11, 11) = cb * Em(11, 11) + Crate * c9
            Em(12, 12) = cb * Em(12, 12) + Crate * c9
        End If

        For ib = 1 To Nvar
            For j = 1 To Nvar
                sm = 0
                For k = 1 To Nvar
                    sm = sm + Em(ib, k) * Trans(k, j)
                Next k
                Emb(ib, j) = sm
            Next j
        Next ib

        For ib = 1 To Nvar
            For j = 1 To Nvar
                sm = 0
                For k = 1 To Nvar
                    sm = sm + Trans(k, ib) * Emb(k, j)
                Next k
                Em(ib, j) = sm
            Next j
        Next ib

    End Sub

    Private Sub CosCalc()
        '部材の方向余弦の計算
        Dim ie, j, k1, k2 As Integer
        Dim b1 As Double
        Dim buf(3) As Double
        For ie = 1 To Nelem
            k1 = NNelem(ie, 1)
            k2 = NNelem(ie, 2)
            buf(1) = Xdata(k2) - Xdata(k1)
            buf(2) = Ydata(k2) - Ydata(k1)
            buf(3) = Zdata(k2) - Zdata(k1)
            b1 = 0
            For j = 1 To 3
                b1 = b1 + buf(j) * buf(j)
            Next j
            RlenBar(ie) = Math.Sqrt(b1)
            For j = 1 To 3
                CosXBar(ie, j) = buf(j) / RlenBar(ie)
            Next j
            b1 = CosXBar(ie, 2) * CosYBar(ie, 3)
            CosZBar(ie, 1) = b1 - CosXBar(ie, 3) * CosYBar(ie, 2)
            b1 = CosXBar(ie, 3) * CosYBar(ie, 1)
            CosZBar(ie, 2) = b1 - CosXBar(ie, 1) * CosYBar(ie, 3)
            b1 = CosXBar(ie, 1) * CosYBar(ie, 2)
            CosZBar(ie, 3) = b1 - CosXBar(ie, 2) * CosYBar(ie, 1)
        Next ie
    End Sub

    Private Sub ElemMatrix(ByVal ie As Integer)
        '要素ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        Dim ib, id, ii, j, k, nb As Integer

        j = 0
        For ii = 1 To 2
            ib = NNelem(ie, ii)
            If Ntype < 3 Then
                k = Ndim * (ib - 1)
                For id = 1 To Ndim
                    j = j + 1
                    k = k + 1
                    NPrefer(j) = k
                Next id
            Else
                k = LrD(ib) - 1
                nb = NvarPD(ib)
                For id = 1 To 6
                    j = j + 1
                    k = k + 1
                    If id > nb Then
                        NPrefer(j) = 0
                    Else
                        NPrefer(j) = k
                    End If
                Next id
            End If
        Next ii

        For ib = 1 To Nvar
            For j = 1 To Nvar
                Em(ib, j) = 0
                Trans(ib, j) = 0
            Next j
        Next ib

        Call TransMatrix(ie)    '座標変換行列の設定

        If Ntype < 3 Then
            Call CoeffMatrix(ie)    '各要素の係数ﾏﾄﾘｯｸｽの計算
        Else
            Call CoeffMatrix2(ie)    '各要素の係数ﾏﾄﾘｯｸｽの計算
        End If

    End Sub

    Private Sub InitialSet1()
        '初期設定
        Dim ib, ii, ip, j, nb As Integer
        If Ntype = 1 Then
            Nvar = 6
        Else
            Nvar = 12
        End If

        Nall = Ndim * Npoint
        ReDim NPrefer(Nvar)
        ReDim Kdispmb(Nall), Nodemb(Nall)
        ReDim KdispMatR(Nall), NodeMatR(Nall)
        ReDim CosXBar(Nelem, 3), CosZBar(Nelem, 3)
        ReDim Trans(Nvar, Nvar)
        ReDim Em(Nvar, Nvar), Emb(Nvar, Nvar)
        ReDim RlenBar(Nelem)
        ReDim RMmatb(Nall)
        ReDim RMmatrix(Nall)

        Call CosCalc()  '部材の方向余弦の計算

        If Ntype < 3 Then
            '行列の変数番号の対応設定
            For ip = 1 To Npoint
                ii = Ndim * (ip - 1)
                ib = 0
                For j = 1 To Ndim
                    ii = ii + 1
                    ib = ib + 1
                    Nodemb(ii) = ip
                    Kdispmb(ii) = ib
                Next j
            Next ip
        Else
            ReDim LrD(Npoint), NvarPD(Npoint)
            Call NvarPDSet()     '元ﾃﾞｰﾀ節点の変数の数を設定
            '行列の変数番号の対応設定
            ii = 0
            For ip = 1 To Npoint
                nb = NvarPD(ip)
                ib = 0
                LrD(ip) = ii + 1
                For j = 1 To nb
                    ii = ii + 1
                    ib = ib + 1
                    Nodemb(ii) = ip
                    Kdispmb(ii) = ib
                Next j
            Next ip
        End If

    End Sub

    Private Sub MatrixReduct()
        '行列の縮減
        Dim i, ii As Integer
        Norder = Nall
        ii = 0
        For i = 1 To Nall
            If Nodemb(i) = 0 Then
                Norder = Norder - 1
            Else
                ii = ii + 1
                NodeMatR(ii) = Nodemb(i)
                KdispMatR(ii) = Kdispmb(i)
                RMmatrix(ii) = RMmatb(i)
            End If
        Next i

    End Sub

    Private Sub ReqTime(ByVal crate As Single, ByVal rmesh As Single, _
     ByVal b1 As Single)
        '残りの所要時間の計算
        'crate･･･調整係数
        'rmesh･･･残存ﾒｯｼｭ数
        'b1･･･計算の時間差（秒単位）
        Dim aa$, tima$
        Dim b2 As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics

        tima$ = ""
        If b1 < 0 Then
            b1 = b1 + 86400
        End If
        b2 = b1 * rmesh / crate
        Call TimConv(tima$, b2)
        aa$ = "残り " & tima$
        gr.Clear(Color.White)
        gr.DrawString(aa$, New Font("ＭＳ ゴシック", 9), Brushes.Black, 1, 1)
        gr.Dispose()

    End Sub

    Private Sub Store()
        '全体ﾏﾄﾘｯｸｽへの蓄積
        Dim i, it As Integer
        For i = 1 To Nvar
            it = NPrefer(i)
            If it > 0 Then
                RMmatb(it) = RMmatb(it) + Em(i, i)
            End If
        Next i
    End Sub

    Private Sub TimConv(ByRef tima$, ByVal rsec As Single)
        '秒数から時分秒への換算
        'tima$･･･時分秒表示の時間
        'rsec･･･秒単位の時間
        Dim rhour, rmin As Single
        rhour = Int(rsec / 3600)
        rsec = rsec - rhour * 3600
        rmin = Int(rsec / 60)
        rsec = CInt(rsec + 1 - rmin * 60)
        tima$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(rsec) + "s"

    End Sub

    Private Function TimeLap(ByVal date1 As Date, ByVal date2 As Date) As Single
        '経過時間の計算（1日以内）
        'date1･･･開始時刻
        'date2･･･終了時刻
        Dim sec1, sec2 As Single
        If date1.Date <> date2.Date Then
            sec2 = 3600 * 24
        End If
        sec1 = 3600 * date1.Hour + 60 * date1.Minute + date1.Second
        sec1 = sec1 + 0.001 * date1.Millisecond
        sec2 = sec2 + 3600 * date2.Hour + 60 * date2.Minute + date2.Second
        sec2 = sec2 + 0.001 * date2.Millisecond
        TimeLap = sec2 - sec1

    End Function

    Private Sub TransMatrix(ByVal ie As Integer)
        '座標変換行列の設定
        'ie･･･要素番号
        Dim ib, j As Integer
        Dim b1 As Single
        Dim buf(3, 3) As Single
        For ib = 1 To 3
            For j = 1 To 3
                Select Case ib
                    Case 1
                        b1 = CosXBar(ie, j)
                    Case 2
                        b1 = CosYBar(ie, j)
                    Case 3
                        b1 = CosZBar(ie, j)
                End Select
                buf(ib, j) = b1
            Next j
        Next ib
        For ib = 1 To 3
            For j = 1 To 3
                b1 = buf(ib, j)
                Trans(ib, j) = b1
                Trans(ib + 3, j + 3) = b1
                If Ntype > 1 Then
                    Trans(ib + 6, j + 6) = b1
                    Trans(ib + 9, j + 9) = b1
                End If
            Next j
        Next ib
    End Sub

    Private Sub Bars3EPVRCal3a_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim aa$, fxb$, timn$
        Dim ib, ic, icount, id, ie, ix, j, k, kh, nb As Integer
        Dim df, fwx, rdif, rmesh, rmeshsum, sec, ub As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        Me.Show()

        Crate = 0.001
        fxb$ = ""
        timn$ = ""
        Call TimCal(0, timn$)   'ﾀｲﾏｰ計算（時間ｸﾘｱ）

        Label1.Text = "計算実施中！"
        Label2.Text = "しばらくお待ちください。"
        Label3.Text = ""
        Me.Refresh()

        Fw1 = 0 : Fw2 = 100
        fwx = 0

        df = Fw2 / Nelem
        rmeshsum = Nelem   'ﾒｯｼｭ合計

        Call VCosCalc(kh) '断面ＹB軸の方向余弦計算
        If kh > 0 Then
            Exit Sub
        End If

        Call InitialSet1()  '初期設定

        Label3.Text = "質量ﾏﾄﾘｯｸｽと剛性ﾏﾄﾘｯｸｽの計算"
        ic = 0
        Application.DoEvents()
        icount = 0
        For ie = 1 To Nelem
            Call ElemMatrix(ie)     '要素ﾏﾄﾘｯｸｽの計算
            Call Store()            '全体ﾏﾄﾘｯｸｽへの蓄積

            '進行表示
            fwx = fwx + df
            ProgressBar1.Value = fwx
            If ic = 9 Then
                rmesh = ie
                Dim timenew As Date = Now
                sec = TimeLap(Timst, timenew)
                rdif = rmeshsum - rmesh
                Call ReqTime(rmesh, rdif, sec)     '残りの所要時間の計算
                ic = 0
            Else
                ic = ic + 1
            End If
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        '拘束条件処理
        For ib = 1 To Nbound
            ub = 0
            If Ntype < 3 Then
                j = Ndim * (Nrest(ib) - 1)
                If Ntype = 1 Then
                    nb = 3
                Else
                    nb = 6
                End If
            Else
                k = Nrest(ib)
                j = LrD(k) - 1
                nb = NvarPD(k)
            End If
            For id = 1 To nb
                If Jdirect(ib, id) > 0 Then
                    k = j + id
                    Nodemb(k) = 0
                End If
            Next id
        Next ib

        Application.DoEvents()
        Call MatrixReduct()    '行列の縮減

        gr.Clear(Color.White)

        Call TimCal(1, timn$)   'ﾀｲﾏｰ計算
        aa$ = "END   " & timn$
        Label1.Text = "計算終了！"
        Label2.Text = "ﾏﾄﾘｯｸｽﾃﾞｰﾀを算出しました。"
        Label3.Text = aa$

        aa$ = "ﾏﾄﾘｯｸｽﾃﾞｰﾀを振動解析用ファイルに保存しますか？"
        Me.BringToFront()
        ix = MsgBox(aa$, 4, "ファイル保存")
        If ix = 6 Then
            KindVEqua = 0
            NPvib = 1
            NLvib = 1
            NvibTime = 1
            ReDim KPvib(1), JLoadVib(1, 6)
            ReDim FLvibTime(1, 1)
            KindLvib = 0
            Call FileName(Fstruct$, fxb$)     'ﾌｧｲﾙ名から拡張子なしの部分を取得
            Fm$ = fxb$ + "VR" + ".dat"
            InOut = 1
            Dim frm As Form = New AnalDat6() 'ﾌｧｲﾙへの保存
            frm.Show()
        End If
        Me.Close()

    End Sub
End Class
